#include "linia.h"

Linia::Linia(double a, double b):Wielomian(1)
{
	wsp[0]=b;
	wsp[1]=a;
	nazwa = "Linia";
}

double Linia::MiejsceZerowe() const
{
	return (-wsp[0]/wsp[1]);
}

Linia::Linia(Punkt p1, Punkt p2):Wielomian(1)
{
	if(p1.x==p2.x) wsp[0]=wsp[1]=0.0;
	else
	{
		double t=(p2.y-p1.y)/(p2.x-p1.x);
		wsp[1]=t;
		wsp[0]=p1.y-t*p1.x;
	}
}

Punkt Linia::PunktPrzeciecia(const Linia& l) const
{
	Punkt p;
	if(wsp[1]!=l.wsp[1])
	{
		p.x=(l.wsp[0]-wsp[0])/(l.wsp[1]-wsp[1]);
		p.y=l.wsp[1]*p.x+l.wsp[0];
	}
	return p;
}


Linia Linia::Prostopadla(double x)
{
	Punkt p(x,this->operator()(x));
	return Prostopadla(p);
}

Linia Linia::Prostopadla(Punkt p) const
{
	Linia l(0,0);
	if(wsp[1]!=0)
	{
		l.wsp[1]=-1/wsp[1];
		l.wsp[0]=p.y-p.x/wsp[1];
	}
	return l;
} 